const instrumentsClassfiy: any = {
	"2": ["Flute"],
	"4": ["Clarinet"],
	"6": ["Soprano Sax", "Alto Sax", "Tenor Sax", "Baritone Sax", "Soprano Saxophone", "Alto Saxophone", "Tenor Saxophone", "Baritone Saxophone"],
	"12": ["Trumpet", "Muted Trumpet"],
	"13": ["Horn in F", "French Horn"],
	"14": ["Trombone"],
	"15": ["Euphonium"],
	"17": ["Tuba"],
	"23": [
		"Tinkle Bell",
		"Agogo",
		"Steel Drums",
		"Woodblock",
		"Taiko Drum",
		"Melodic Tom",
		"Synth Drums",
		"Reverse Cymbals",
		"Acoustic Bass Drum",
		"Bass Drum",
		"Side Drum",
		"Acoustic Snare",
		"Hand Claps",
		"Electric Snare",
		"Low Floor Tom",
		"Closed Hi-Hat",
		"High Floor Tom",
		"Pedal Hi-Hat",
		"Low Tom",
		"Open Hi-Hat",
		"Low-Mid Tom",
		"Hi Mid Tom",
		"Crash Cymbals",
		"High Tom",
		"Ride Cymbals",
		"Chinese Cymbals",
		"Ride Bell",
		"Tambourine",
		"Splash Cymbal",
		"Cowbell",
		"Crash Cymbal",
		"Vibra-Slap",
		"Ride Cymbal",
		"Hi Bongo",
		"Low Bongo",
		"Mute Hi Conga",
		"Open Hi Conga",
		"Low Conga",
		"High Timbale",
		"Low Timbale",
		"High Agogo",
		"Low Agogo",
		"Cabasa",
		"Maracas",
		"Short Whistle",
		"Long Whistle",
		"Short Guiro",
		"Long Guiro",
		"Claves",
		"Hi Wood Block",
		"Low Wood Block",
		"Mute",
		"Open",
		"Mute Triangle",
		"Open Triangle",
		"Snare Drum",
		"Cymbal",
		"Cymbals",
		"Triangle",
		"Vibrato",
		"Suspend Cymbals",
		"Suspended Cymbals",
		"Tom-Toms",
		"Bell",
		"Bells",
		"crash cymbals",
		"Suspend cymbals",
		"Castanets",
		"Drum Set",
		"Gong",
		"Shaker",
		"Mark tree",
		"Chimes",
		"Mark Tree",
		"Tom-toms",
		"Hi-Hat",
		"Sleigh Bells",
		"Flexatone",
		"Brake drum",
		"concert tom",
		"brake drum",
		"finger cymbal",
		"ride cymbal",
		"Concert Toms",
		"Vibraslap",
		"Wood Blocks",
		"Temple Blocks",
		"Wood Block",
	],
	"134": ["Ocarina"],
	"135": ["Pan Flute"],
	"136": ["Hulusi flute"],
	"137": ["Melodica"],
	Oboe: ["Oboe"],
	"English Horn": ["English Horn"],
	Bassoon: ["Bassoon"],
	Piccolo: ["Piccolo"],
	Recorder: ["Recorder"],
	"Soprano Recorder": ["Soprano Recorder"],
	DYOther: [
		"Acoustic Grand Piano",
		"Bright Acoustic Piano",
		"Electric Grand Piano",
		"Rhodes Piano",
		"Chorused Piano",
		"Harpsichord",
		"Clavichord",
		"Celesta",
		"Glockenspiel",
		"Music box",
		"Vibraphone",
		"Marimba",
		"Xylophone",
		"Tubular Bells",
		"Dulcimer",
		"Hammond Organ",
		"Percussive Organ",
		"Rock Organ",
		"Church Organ",
		"Reed Organ",
		"Accordian",
		"Harmonica",
		"Tango Accordian",
		"Acoustic Guitar",
		"Electric Guitar",
		"Overdriven Guitar",
		"Distortion Guitar",
		"Guitar Harmonics",
		"Acoustic Bass",
		"Electric Bass",
		"Fretless Bass",
		"Slap Bass",
		"Synth Bass",
		"Violin",
		"Viola",
		"Cello",
		"Contrabass",
		"Tremolo Strings",
		"Pizzicato Strings",
		"Orchestral Harp",
		"Timpani",
		"String Ensemble",
		"Synth Strings",
		"Choir Aahs",
		"Voice Oohs",
		"Synth Voice",
		"Orchestra Hit",
		"Brass Section",
		"Synth Brass",
		"Bottle Blow",
		"Whistle",
		"Lead",
		"Lead lead",
		"Pad age",
		"Pad",
		"FX",
		"Sitar",
		"Banjo",
		"Shamisen",
		"Koto",
		"Kalimba",
		"Bagpipe",
		"Fiddle",
		"Shanai",
		"Agogos",
		"Melodic Toms",
		"Agogo Bells",
		"Taiko Drums",
		"Bongos",
		"Bongo Bell",
		"Congas",
		"Guiro",
		"Guitar Fret Noise",
		"Breath Noise",
		"Seashore",
		"Bird Tweet",
		"Telephone Ring",
		"Helicopter",
		"Applause",
		"Gunshot",
		"Bass Clarinet",
		"Cornet",
		"Sleigh Bells",
		"Field Drum",
		"Quad-Toms",
		"Quads",
		"Drums set",
		"High Bongo",
		"Timbales",
	],
};

export const getInstrumentsClassfiy = (name: string) => {
	name = name.toLocaleLowerCase().replaceAll(" ", "");
	for (let key in instrumentsClassfiy) {
		const names = instrumentsClassfiy[key];
		for (let i = 0, len = names.length; i < len; i++) {
			const _key = names[i].toLocaleLowerCase().replaceAll(" ", "");
			if (_key.includes(name) || name.includes(_key)) {
				return key;
			}
		}
	}
  return 0
};
